config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.cyrus-imapd.new
config etc/cyrus.conf.new
config etc/imapd.conf.new
( cd usr/bin ; rm -rf mupdatetest )
( cd usr/bin ; ln -sf imtest mupdatetest )
( cd usr/bin ; rm -rf nntptest )
( cd usr/bin ; ln -sf imtest nntptest )
( cd usr/bin ; rm -rf smtptest )
( cd usr/bin ; ln -sf imtest smtptest )
( cd usr/bin ; rm -rf synctest )
( cd usr/bin ; ln -sf imtest synctest )
( cd usr/bin ; rm -rf pop3test )
( cd usr/bin ; ln -sf imtest pop3test )
( cd usr/bin ; rm -rf lmtptest )
( cd usr/bin ; ln -sf imtest lmtptest )
( cd usr/bin ; rm -rf sivtest )
( cd usr/bin ; ln -sf imtest sivtest )
( cd usr/lib ; rm -rf libcyrus_imap.so )
( cd usr/lib ; ln -sf libcyrus_imap.so.0.0.0 libcyrus_imap.so )
( cd usr/lib ; rm -rf libcyrus.so.0 )
( cd usr/lib ; ln -sf libcyrus.so.0.0.0 libcyrus.so.0 )
( cd usr/lib ; rm -rf libcyrus_imap.so.0 )
( cd usr/lib ; ln -sf libcyrus_imap.so.0.0.0 libcyrus_imap.so.0 )
( cd usr/lib ; rm -rf libcyrus_min.so )
( cd usr/lib ; ln -sf libcyrus_min.so.0.0.0 libcyrus_min.so )
( cd usr/lib ; rm -rf libcyrus_sieve.so.0 )
( cd usr/lib ; ln -sf libcyrus_sieve.so.0.0.0 libcyrus_sieve.so.0 )
( cd usr/lib ; rm -rf libcyrus_sieve.so )
( cd usr/lib ; ln -sf libcyrus_sieve.so.0.0.0 libcyrus_sieve.so )
( cd usr/lib ; rm -rf libcyrus.so )
( cd usr/lib ; ln -sf libcyrus.so.0.0.0 libcyrus.so )
( cd usr/lib ; rm -rf libcyrus_min.so.0 )
( cd usr/lib ; ln -sf libcyrus_min.so.0.0.0 libcyrus_min.so.0 )
( cd usr/libexec/cyrus ; rm -rf pop3proxyd )
( cd usr/libexec/cyrus ; ln -sf pop3d pop3proxyd )
( cd usr/libexec/cyrus ; rm -rf lmtpproxyd )
( cd usr/libexec/cyrus ; ln -sf lmtpd lmtpproxyd )
( cd usr/libexec/cyrus ; rm -rf proxyd )
( cd usr/libexec/cyrus ; ln -sf imapd proxyd )
